# cleanbib.pl - Clean up BibTeX sources with BibTeX::Parser

## Synopsis

    [perl] cleanbib.pl [-DdEeghijLlnosTtUu] [long options...] [>utf8-output.bib]
    
## Description

This program is mainly a CLI for cleaning up BibTeX .bib files with the
help of [BibTeX::Parser][]. Its main, and originally only, functionality
is to replace LaTeX macros with Unicode characters. There is an option
to turn this *off* if you don't like it. Later I added some options for
setting some options for [BibTeX::Parser::Entry][] options (note that
this program's defaults sometimes differ from the module's defaults!),
and most recently for joining the **subtitle** field to the **title**
field with a separator (by default a full stop followed by a space.)

[BibTeX::Parser]: https://metacpan.org/pod/BibTeX::Parser
[BibTeX::Parser::Entry]: https://metacpan.org/pod/BibTeX::Parser::Entry
    
## Installation

### Perl

This program is written in Perl, so it obviously needs Perl to be
installed. If you are on Linux, Mac or another Unix-like OS you probably
already got it. If not see

Getting perl: <https://www.perl.org/get.html>

(For Windows I recommend Strawberry Perl as module installation is easier there.)

### Modules

TL;DR:

    cpan App::cpanminus
    cpanm utf8::all BibTeX::Parser Getopt::Long::Descriptive Path::Tiny

This script needs the following Perl modules from [CPAN][]:

-   utf8::all
-   BibTeX::Parser
-   Getopt::Long::Descriptive
-   Path::Tiny

For the details on installing Perl modules: <http://www.cpan.org/modules/INSTALL.html>

[CPAN]: https://www.cpan.org/misc/cpan-faq.html#What_is_CPAN

## Options
    
	--input-file STR (or -i)       Source BibTeX file name.
	--output-file STR (or -o)      Target BibTeX file name.
	--input-encoding STR (or -e)   Input file encoding.
	                               (default value: UTF-8)
	--output-encoding STR (or -E)  Output file encoding.
	                               (default value: UTF-8)
	-e and -E values may be Perl binmode
	string containing ":".       
	--join-title (or -j)           Join title and subtitle into title.
	--sep STR (or -s)              Separator between title and subtitle.
	                               Defaults to env var BIB_SUBTITLE_SEP
	                               or ". ". Must explicitly contain any
	                               whitespace!
	                               (default value: . )
	--decode (or -d)               Replace LaTeX macros with Unicode
	                               characters.
	                               (default value: 1)
	--no-decode (or -D)            Do not replace LaTeX macros with
	                               Unicode characters.
	--decode-german (or -g)        Decode with german conventions. ("a
	                               for \"a etc.)
	--fields-lower-case (or -l)    Make field names lowercase. (Default.)
	--fields-title-case (or -t)    Make field names titlecase.
	--fields-upper-case (or -u)    Make field names uppercase.
	--types-lower-case (or -L)     Make type names lowercase.
	--types-title-case (or -T)     Make type names titlecase. (Default.)
	--types-upper-case (or -U)     Make type names uppercase.
	--canonize-names (or -n)       Print author and editor fields in
	                               canonical BibTeX format.
	--help (or -h)                 Print usage help and exit.
    
## Author

Benct Philip Jonsson <bpjonsson@gmail.com>

## Copyright and license

This software is copyright (c) 2022 by Benct Philip Jonsson.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

http://dev.perl.org/licenses/

